#execute as @r at @s unless entity @e[type=minecraft:marker,tag=bed_vote_stand] run function bedvote:setup

execute as @a[scores={is_sleeping=1..},predicate=bedvote:dimension/minecraft/overworld] unless entity @e[type=minecraft:marker,tag=bed_vote_stand,scores={vote_timer=1..}] unless entity @e[type=minecraft:marker,tag=bed_vote_stand,scores={cooldown=1..}] run function bedvote:vote_start
execute as @a[scores={is_sleeping=1..},predicate=bedvote:dimension/minecraft/overworld] unless entity @e[type=minecraft:marker,tag=bed_vote_stand,scores={vote_timer=1..}] if entity @e[type=minecraft:marker,tag=bed_vote_stand,scores={cooldown=1..}] run function bedvote:vote_cooldown

execute as @e[type=minecraft:marker,tag=bed_vote_stand,scores={vote_timer=2..}] run scoreboard players enable @a[tag=!voted] y
execute as @e[type=minecraft:marker,tag=bed_vote_stand,scores={vote_timer=2..}] run scoreboard players enable @a[tag=!voted] n
execute if entity @e[type=minecraft:marker,tag=bed_vote_stand,scores={vote_timer=2..}] as @a[scores={y=1..}] run function bedvote:voteyes
execute if entity @e[type=minecraft:marker,tag=bed_vote_stand,scores={vote_timer=2..}] as @a[scores={n=1..}] run function bedvote:voteno

execute as @e[type=minecraft:marker,tag=bed_vote_stand,tag=yes_wins] run time add 100
execute store result score @e[type=minecraft:marker,tag=bed_vote_stand] daytime run time query daytime
tag @e[type=minecraft:marker,scores={daytime=1..12000},tag=bed_vote_stand,tag=yes_wins] remove yes_wins

execute as @e[type=minecraft:marker,tag=bed_vote_stand,scores={vote_timer=1}] if score @s y > @s n run function bedvote:yes_wins
execute as @e[type=minecraft:marker,tag=bed_vote_stand,scores={vote_timer=1}] if score @s y < @s n run function bedvote:no_wins
execute as @e[type=minecraft:marker,tag=bed_vote_stand,scores={vote_timer=1}] if score @s y = @s n run function bedvote:tie

#Win due to all players voting
execute as @e[type=minecraft:marker,tag=bed_vote_stand,scores={vote_timer=2..}] unless entity @a[tag=!voted] if score @e[type=minecraft:marker,tag=bed_vote_stand,limit=1] y > @e[type=minecraft:marker,tag=bed_vote_stand,limit=1] n run function bedvote:yes_wins
execute as @e[type=minecraft:marker,tag=bed_vote_stand,scores={vote_timer=2..}] unless entity @a[tag=!voted] if score @e[type=minecraft:marker,tag=bed_vote_stand,limit=1] y < @e[type=minecraft:marker,tag=bed_vote_stand,limit=1] n run function bedvote:no_wins
execute as @e[type=minecraft:marker,tag=bed_vote_stand,scores={vote_timer=2..}] unless entity @a[tag=!voted] if score @e[type=minecraft:marker,tag=bed_vote_stand,limit=1] y = @e[type=minecraft:marker,tag=bed_vote_stand,limit=1] n run function bedvote:tie

scoreboard players reset @e[type=minecraft:marker,tag=bed_vote_stand,scores={vote_timer=1}] y
scoreboard players reset @e[type=minecraft:marker,tag=bed_vote_stand,scores={vote_timer=2}] y
execute as @e[type=minecraft:marker,tag=bed_vote_stand,scores={vote_timer=1}] run tag @a remove voted
scoreboard players remove @e[type=minecraft:marker,tag=bed_vote_stand,scores={vote_timer=1..}] vote_timer 1
scoreboard players remove @e[type=minecraft:marker,tag=bed_vote_stand,scores={cooldown=1..}] cooldown 1
scoreboard players reset @a is_sleeping
#I have no idea why, but removing this makes it not work
scoreboard players reset @e[type=minecraft:marker,tag=!bed_vote_stand] vote_timer